## deepin-unioncode 1.4.13

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18.0)

project(deepin-unioncode)

message("processor: ${CMAKE_SYSTEM_PROCESSOR}")

function(print_directory arg)
    execute_process(COMMAND ls ${ARGV0} OUTPUT_VARIABLE outVar)
    message(STATUS "print_directory native: ${ARGV0}\n" ${outVar})
endfunction()

set(VERSION $ENV{VERSION})
# build with -fPIC flag in .a library on arm64
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

if (NOT VERSION)
    set(VERSION "0.0.1")
endif()

message(STATUS "build version ${VERSION}")
option(ENABLE_SANITIZE_CHECK "Enable Sanitize Check " OFF) 

set(CMAKE_VERBOSE_MAKEFILE ON)

if (ENABLE_SANITIZE_CHECK AND (CMAKE_BUILD_TYPE STREQUAL "Debug"))
    message("debug type open sanitize check")
    set(CMAKE_CXX_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer")
    set(CMAKE_C_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer")
    set(CMAKE_L_FLAGS "-fsanitize=undefined,address,leak -fno-omit-frame-pointer")
#    set(CMAKE_CXX_FLAGS "-fsanitize=thread")
#    set(CMAKE_C_FLAGS "-fsanitize=thread")
#    set(CMAKE_L_FLAGS "-fsanitize=thread")
endif()

set(LIBRARY_INSTALL_PREFIX "/usr/lib/${CMAKE_LIBRARY_ARCHITECTURE}/${PROJECT_NAME}")

#set(ARCHIVE_INSTALL_RPEFIX "") undefined the static lib archive
set(RUNTIME_INSTALL_RPEFIX "/usr/bin")
set(SOURCES_INSTALL_RPEFIX "/usr/share/${PROJECT_NAME}")
set(INCLUDE_INSTALL_RPEFIX "/usr/include/${PROJECT_NAME}")

set(PLUGIN_INSTALL_PATH ${LIBRARY_INSTALL_PREFIX}/plugins)
set(TOOLS_INSTALL_PATH ${LIBRARY_INSTALL_PREFIX}/tools)
# set install runtime path
set(CMAKE_INSTALL_RPATH ${LIBRARY_INSTALL_PREFIX} ${PLUGIN_PATH})

message(STATUS "LIBRARY_INSTALL_PREFIX ${LIBRARY_INSTALL_PREFIX}")
message(STATUS "RUNTIME_INSTALL_RPEFIX ${RUNTIME_INSTALL_RPEFIX}")
message(STATUS "SOURCES_INSTALL_RPEFIX ${SOURCES_INSTALL_RPEFIX}")
message(STATUS "INCLUDE_INSTALL_RPEFIX ${INCLUDE_INSTALL_RPEFIX}")
message(STATUS "PLUGIN_INSTALL_PATH ${PLUGIN_INSTALL_PATH}")
message(STATUS "TOOLS_INSTALL_PATH ${TOOLS_INSTALL_PATH}")
message(STATUS "CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_RPATH}")

# build runtime path
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/build/${CMAKE_BUILD_TYPE})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/build/${CMAKE_BUILD_TYPE})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/build/${CMAKE_BUILD_TYPE})
link_directories(${CMAKE_LIBRARY_OUTPUT_DIRECTORY})

add_definitions(-DQT_MESSAGELOGCONTEXT)

# Setup the environment
set(CMAKE_CXX_STANDARD 17)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

if ((${CMAKE_SYSTEM_PROCESSOR} STREQUAL "sw_64")
        OR (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "loongarch64")
        OR (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "mips64")
        )
    message(STATUS "add cmake params found thread library from ${CMAKE_SYSTEM_PROCESSOR}")
    set(CMAKE_THREAD_LIBS_INIT "-lpthread")
    set(CMAKE_HAVE_THREADS_LIBRARY ON)
    set(CMAKE_USE_WIN32_THREADS_INIT OFF)
    set(CMAKE_USE_PTHREADS_INIT ON)
    set(THREADS_PREFER_PTHREAD_FLAG ON)
endif()

set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wl,--as-need -fPIE")

find_package(Qt6 COMPONENTS Core QUIET)
if (Qt6_FOUND)
    set(QT_VERSION_MAJOR 6)
else()
    find_package(Qt5 COMPONENTS Core REQUIRED)
    set(QT_VERSION_MAJOR 5)
endif()
message("   >>> Found Qt version: ${QT_VERSION_MAJOR}")

if (QT_VERSION_MAJOR MATCHES 6)
    set(DTK_VERSION_MAJOR 6)
    set(KF_VERSION_MAJOR 6)
else()
    set(DTK_VERSION_MAJOR "")
    set(KF_VERSION_MAJOR 5)
endif()
message("   >>> Build with DTK: ${DTK_VERSION_MAJOR}")

find_package(Dtk${DTK_VERSION_MAJOR} COMPONENTS Widget REQUIRED)
include_directories(${PROJECT_NAME} PRIVATE ${DtkWidget_INCLUDE_DIRS})

# Use Qt modules no WebEngineWidgets WebChannel
set(QtFindModules Core Gui Widgets Concurrent Network DBus)

foreach(QtModule ${QtFindModules})
    find_package(Qt${QT_VERSION_MAJOR} COMPONENTS ${QtModule} REQUIRED)
    # include qt module private include directors
    include_directories(${Qt${QT_VERSION_MAJOR}${QtModule}_PRIVATE_INCLUDE_DIRS})
    # can use target_link_libraries(xxx ${QtUseModules})
    list(APPEND QtUseModules "Qt${QT_VERSION_MAJOR}::${QtModule}")
    message("QtModule found ${QtModule} OK!")
endforeach()

set(PkgConfigFindModules)
include(FindPkgConfig)
foreach(PkgConfigModule ${PkgConfigFindModules})
    pkg_check_modules(PkgUseModuleVal REQUIRED ${PkgConfigModule})
    list(APPEND PkgUseModules ${PkgUseModuleVal_LDFLAGS})
    include_directories(${PkgUseModuleVal_INCLUDE_DIRS})
endforeach(PkgConfigModule)

include_directories(${PROJECT_SOURCE_DIR}/src)

option(ENABLE_UNIT_TESTS "Enable unit tests" OFF)
message(STATUS "Enable testing: ${ENABLE_UNIT_TESTS}")
if(ENABLE_UNIT_TESTS)
    enable_testing()
    add_subdirectory(tests)
endif()

# sub directories
add_subdirectory(3rdparty)
add_subdirectory(src)
add_subdirectory(assets)

=== 3rdparty/CMakeLists.txt ===
add_subdirectory(cppdap)
add_subdirectory(unioncode-qscintilla214)
if (QT_VERSION_MAJOR MATCHES 5)
add_subdirectory(unioncode-GitQlient)
endif()
add_subdirectory(unioncode-qtermwidget-0.14.1)
add_subdirectory(unioncode-jsonrpccpp)

=== assets/CMakeLists.txt ===
# install templates.
install(DIRECTORY templates/
    DESTINATION "${SOURCES_INSTALL_RPEFIX}/templates")
install(DIRECTORY models/
    DESTINATION "${SOURCES_INSTALL_RPEFIX}/models")

find_package(Qt${QT_VERSION_MAJOR} COMPONENTS LinguistTools)

# install translation.
if (CMAKE_BUILD_TYPE STREQUAL "Release")
    file(GLOB TS_FILES "translations/*.ts")
    foreach(TS_FILE IN LISTS TS_FILES)
        message(STATUS "process ts file: ${TS_FILE}")
        find_program(LUPDATE_COMMAND NAMES lupdate lupdate-Qt${QT_VERSION_MAJOR} lupdate-qt4 lupdate-pro)
        if (NOT LUPDATE_COMMAND)
            message(FATAL_ERROR "lupdate command not found")
        endif()
        execute_process(COMMAND ${LUPDATE_COMMAND} "${CMAKE_SOURCE_DIR}/src/" -ts -no-obsolete
            "${TS_FILE}"
            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
            OUTPUT_VARIABLE OUTPUT
            ERROR_VARIABLE ERROR
            RESULT_VARIABLE RES)
        if (RES)
            message(FATAL_ERROR "process ts file result : ${RES}, with error: ${ERROR}")
        endif()
        message(STATUS "${OUTPUT}")
        execute_process(COMMAND lrelease ${TS_FILE})
    endforeach()
endif()

file(GLOB QM_FILES "translations/*.qm")
install(FILES ${QM_FILES} DESTINATION "${SOURCES_INSTALL_RPEFIX}/translations")

# install tools
set(TOOL_INSTALL_PATH "/usr/lib/${CMAKE_LIBRARY_ARCHITECTURE}/${CMAKE_PROJECT_NAME}/tools/env")
message("tool install path: ${TOOL_INSTALL_PATH}")
file(GLOB TOOL_FILES "${CMAKE_SOURCE_DIR}/assets/tools/*.tar.gz")
message(STATUS "TOOL_FILES ${TOOL_FILES}")
install(FILES ${TOOL_FILES} DESTINATION ${TOOL_INSTALL_PATH})

# install configure files.
file(GLOB SUPPORTFILES "${CMAKE_CURRENT_SOURCE_DIR}/configures/*.support")
file(GLOB DESKTOPFILES "${CMAKE_CURRENT_SOURCE_DIR}/configures/*.desktop")
file(GLOB ICON "${CMAKE_CURRENT_SOURCE_DIR}/configures/*.svg")

install(FILES ${SUPPORTFILES} DESTINATION "${SOURCES_INSTALL_RPEFIX}/configures")
install(FILES ${DESKTOPFILES} DESTINATION "/usr/share/applications")
install(FILES ${ICON} DESTINATION "${SOURCES_INSTALL_RPEFIX}/configures/icons")

=== src/CMakeLists.txt ===
set(CMAKE_INCLUDE_CURRENT_DIR ON)
# use outside framework from deepin framework
include_directories(${CMAKE_SOURCE_DIR})
add_subdirectory(framework)
link_libraries(duc-framework)

add_subdirectory(app)
add_subdirectory(base)
add_subdirectory(common)
add_subdirectory(plugins)
add_subdirectory(services)
add_subdirectory(scripts)
add_subdirectory(tools)

=== tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

project(tests)

=== 3rdparty/unioncode-jsonrpccpp/CMakeLists.txt ===
project(unioncode-jsonrpccpp)

set(JSONRPCCPP_ROOT "libjson-rpc-cpp") #1.4.1
############### jsonrpccpp ###############

# setup compiler settings && dependencies
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/${JSONRPCCPP_ROOT}/cmake")
message(STATUS "CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}")

include(CMakeCompilerSettings)
include(CMakeDependencies)

option(HUNTER_ENABLED "Enable Hunter package manager" NO)
include(HunterGate)
HunterGate(
        URL "https://github.com/ruslo/hunter/archive/v0.18.47.tar.gz"
        SHA1 "f0c476a3a0f9edd6182936d8c4460811f112189c"
)

if(NOT MSVC)
    set(BUILD_SHARED_LIBS YES CACHE BOOL "Build shared libraries")
    set(BUILD_STATIC_LIBS NO CACHE BOOL "Build static libraries")
else()
    set(BUILD_SHARED_LIBS NO CACHE BOOL "Build shared libraries")
    set(BUILD_STATIC_LIBS YES CACHE BOOL "Build static libraries")
endif()
set(LIB_SUFFIX "" CACHE STRING "Suffix for library directory (32/64)")

if (NOT BUILD_SHARED_LIBS AND NOT BUILD_STATIC_LIBS)
    message(FATAL_ERROR "Both BUILD_SHARED_LIBS and BUILD_STATIC_LIBS are disabled")
endif()

# defaults for modules that can be enabled/disabled
if(UNIX)
    set(UNIX_DOMAIN_SOCKET_SERVER NO CACHE BOOL "Include Unix Domain Socket server")
    set(UNIX_DOMAIN_SOCKET_CLIENT NO CACHE BOOL "Include Unix Domain Socket client")
    set(FILE_DESCRIPTOR_SERVER NO CACHE BOOL "Include File Descriptor server")
    set(FILE_DESCRIPTOR_CLIENT NO CACHE BOOL "Include File Descriptor client")
endif(UNIX)

set(TCP_SOCKET_SERVER YES CACHE BOOL "Include Tcp Socket server")
set(TCP_SOCKET_CLIENT YES CACHE BOOL "Include Tcp Socket client")
set(SERIAL_PORT_SERVER NO CACHE BOOL "Include Serial port server")
set(SERIAL_PORT_CLIENT NO CACHE BOOL "Include Serial port client")
set(REDIS_SERVER NO CACHE BOOL "Include Redis server using hiredis")
set(REDIS_CLIENT NO CACHE BOOL "Include Redis client using hiredis")
set(HTTP_SERVER NO CACHE BOOL "Include HTTP server using libmicrohttpd")
set(HTTP_CLIENT NO CACHE BOOL "Include HTTP client support using curl")
set(COMPILE_TESTS NO CACHE BOOL "Compile test framework")
set(COMPILE_STUBGEN NO CACHE BOOL "Compile the stubgenerator")
set(COMPILE_EXAMPLES NO CACHE BOOL "Compile example programs")

option(WITH_COVERAGE "Build with code coverage flags" OFF)

# print actual settings
if(UNIX)
    message(STATUS "UNIX_DOMAIN_SOCKET_SERVER: ${UNIX_DOMAIN_SOCKET_SERVER}")
    message(STATUS "UNIX_DOMAIN_SOCKET_CLIENT: ${UNIX_DOMAIN_SOCKET_CLIENT}")
endif(UNIX)
message(STATUS "TCP_SOCKET_SERVER: ${TCP_SOCKET_SERVER}")
message(STATUS "TCP_SOCKET_CLIENT: ${TCP_SOCKET_CLIENT}")
message(STATUS "HTTP_SERVER: ${HTTP_SERVER}")
message(STATUS "HTTP_CLIENT: ${HTTP_CLIENT}")
message(STATUS "REDIS_SERVER: ${REDIS_SERVER}")
message(STATUS "REDIS_CLIENT: ${REDIS_CLIENT}")
if(UNIX)
    message(STATUS "UNIXDOMAINSOCKET_SERVER: ${UNIX_DOMAIN_SOCKET_SERVER}")
    message(STATUS "UNIXDOMAINSOCKET_CLIENT: ${UNIX_DOMAIN_SOCKET_CLIENT}")
endif(UNIX)
message(STATUS "COMPILE_TESTS: ${COMPILE_TESTS}")
message(STATUS "COMPILE_STUBGEN: ${COMPILE_STUBGEN}")
message(STATUS "COMPILE_EXAMPLES: ${COMPILE_EXAMPLES}")

# setup common headers and sources
file(GLOB jsonrpc_header ${JSONRPCCPP_ROOT}/*.h)
file(GLOB jsonrpc_header_common ${JSONRPCCPP_ROOT}/src/jsonrpccpp/common/*.h)
file(GLOB jsonrpc_source_common ${JSONRPCCPP_ROOT}/src/jsonrpccpp/common/*.c*)

file(GLOB jsonrpc_header_server ${JSONRPCCPP_ROOT}/src/jsonrpccpp/server/*.h)
file(GLOB jsonrpc_source_server ${JSONRPCCPP_ROOT}/src/jsonrpccpp/server/*.c*)

file(GLOB jsonrpc_header_client ${JSONRPCCPP_ROOT}/src/jsonrpccpp/client/*.h)
file(GLOB jsonrpc_source_client ${JSONRPCCPP_ROOT}/src/jsonrpccpp/client/*.c*)

# setup connector variables defaults
set(client_connector_source "")
set(client_connector_header "")
set(client_connector_libs "")
set(server_connector_source "")
set(server_connector_header "")
set(server_connector_libs "")
set(SERVER_LIBS "")
set(CLIENT_LIBS "")

# setup sources for http connectors
set(CLIENT_CONNECTORS ${JSONRPCCPP_ROOT}/src/jsonrpccpp/client/connectors)
set(SERVER_CONNECTORS ${JSONRPCCPP_ROOT}/src/jsonrpccpp/server/connectors)

if (HTTP_CLIENT)
    list(APPEND client_connector_header "${CLIENT_CONNECTORS}/httpclient.h")
    list(APPEND client_connector_source "${CLIENT_CONNECTORS}/httpclient.cpp")
    list(APPEND client_connector_libs ${CURL_LIBRARIES})
    set(CLIENT_LIBS "${CLIENT_LIBS} -lcurl")
endif ()

if (HTTP_SERVER)
    list(APPEND server_connector_header "${SERVER_CONNECTORS}/httpserver.h")
    list(APPEND server_connector_source "${SERVER_CONNECTORS}/httpserver.cpp")
    list(APPEND server_connector_libs ${CMAKE_THREAD_LIBS_INIT} ${MHD_LIBRARIES})
    set(SERVER_LIBS "${SERVER_LIBS} -lmicrohttpd")
endif ()

# setup sources for redis connectors
if (REDIS_CLIENT)
    list(APPEND client_connector_header "${CLIENT_CONNECTORS}/redisclient.h")
    list(APPEND client_connector_source "${CLIENT_CONNECTORS}/redisclient.cpp")
    list(APPEND client_connector_libs ${HIREDIS_LIBRARIES})
    include_directories(${HIREDIS_INCLUDE_DIRS})
    set(CLIENT_LIBS "${CLIENT_LIBS} -lhiredis")
endif ()

if (REDIS_SERVER)
    list(APPEND server_connector_header "${SERVER_CONNECTORS}/redisserver.h")
    list(APPEND server_connector_source "${SERVER_CONNECTORS}/redisserver.cpp")
    list(APPEND server_connector_libs ${CMAKE_THREAD_LIBS_INIT} ${HIREDIS_LIBRARIES})
    set(SERVER_LIBS "${SERVER_LIBS} -lhiredis")
endif ()

# setup sources for unix domain socket connectors
if (UNIX_DOMAIN_SOCKET_SERVER)
    list(APPEND server_connector_header "${SERVER_CONNECTORS}/unixdomainsocketserver.h")
    list(APPEND server_connector_source "${SERVER_CONNECTORS}/unixdomainsocketserver.cpp")
    list(APPEND server_connector_libs ${CMAKE_THREAD_LIBS_INIT})
endif ()

if (UNIX_DOMAIN_SOCKET_CLIENT)
    list(APPEND client_connector_header "${CLIENT_CONNECTORS}/unixdomainsocketclient.h")
    list(APPEND client_connector_source "${CLIENT_CONNECTORS}/unixdomainsocketclient.cpp")
endif ()

# setup sources for tcp socket connectors
if (TCP_SOCKET_SERVER)
    list(APPEND server_connector_header "${SERVER_CONNECTORS}/tcpsocketserver.h")
    list(APPEND server_connector_source "${SERVER_CONNECTORS}/tcpsocketserver.cpp")
    if (WIN32)
        list(APPEND server_connector_header "${SERVER_CONNECTORS}/windowstcpsocketserver.h")
        list(APPEND server_connector_source "${SERVER_CONNECTORS}/windowstcpsocketserver.cpp")
        list(APPEND server_connector_libs ws2_32)
    endif ()
    if (UNIX)
        list(APPEND server_connector_header "${SERVER_CONNECTORS}/linuxtcpsocketserver.h")
        list(APPEND server_connector_source "${SERVER_CONNECTORS}/linuxtcpsocketserver.cpp")
    endif ()
    list(APPEND server_connector_libs ${CMAKE_THREAD_LIBS_INIT})
endif ()

if (TCP_SOCKET_CLIENT)
    list(APPEND client_connector_header "${CLIENT_CONNECTORS}/tcpsocketclient.h")
    list(APPEND client_connector_source "${CLIENT_CONNECTORS}/tcpsocketclient.cpp")
    if (WIN32)
        list(APPEND client_connector_header "${CLIENT_CONNECTORS}/windowstcpsocketclient.h")
        list(APPEND client_connector_source "${CLIENT_CONNECTORS}/windowstcpsocketclient.cpp")
        list(APPEND client_connector_libs ws2_32)
    endif ()
    if (UNIX)
        list(APPEND client_connector_header "${CLIENT_CONNECTORS}/linuxtcpsocketclient.h")
        list(APPEND client_connector_source "${CLIENT_CONNECTORS}/linuxtcpsocketclient.cpp")
    endif ()
    list(APPEND client_connector_libs ${CMAKE_THREAD_LIBS_INIT})
endif ()

if (SERIAL_PORT_SERVER)
    if (UNIX)
        list(APPEND server_connector_header "${SERVER_CONNECTORS}/linuxserialportserver.h")
        list(APPEND server_connector_source "${SERVER_CONNECTORS}/linuxserialportserver.cpp")
    endif ()
    list(APPEND server_connector_libs ${CMAKE_THREAD_LIBS_INIT})
endif ()

if (SERIAL_PORT_CLIENT)
    if (UNIX)
        list(APPEND client_connector_header "${CLIENT_CONNECTORS}/linuxserialportclient.h")
        list(APPEND client_connector_source "${CLIENT_CONNECTORS}/linuxserialportclient.cpp")
    endif ()
    list(APPEND client_connector_libs ${CMAKE_THREAD_LIBS_INIT})
endif ()

if (FILE_DESCRIPTOR_SERVER)
    list(APPEND server_connector_header "${SERVER_CONNECTORS}/filedescriptorserver.h")
    list(APPEND server_connector_source "${SERVER_CONNECTORS}/filedescriptorserver.cpp")
    list(APPEND server_connector_libs ${CMAKE_THREAD_LIBS_INIT})
endif ()

if (FILE_DESCRIPTOR_CLIENT)
    list(APPEND client_connector_header "${CLIENT_CONNECTORS}/filedescriptorclient.h")
    list(APPEND client_connector_source "${CLIENT_CONNECTORS}/filedescriptorclient.cpp")
    list(APPEND client_connector_libs ${CMAKE_THREAD_LIBS_INIT})
endif ()

# configure a header file to pass some of the CMake settings to the source code
file(MAKE_DIRECTORY "${JSONRPCCPP_ROOT}/src/jsonrpccpp/common")
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/${JSONRPCCPP_ROOT}/src/jsonrpccpp/common/jsonparser.h.in"
    "${CMAKE_CURRENT_SOURCE_DIR}/${JSONRPCCPP_ROOT}/src/jsonrpccpp/common/jsonparser.h"
    )

# include required directories
include_directories(${JSONRPCCPP_ROOT}/src)
include_directories(${MHD_INCLUDE_DIRS})

# setup shared common library
if (BUILD_SHARED_LIBS)
    add_library(unioncode-jsonrpccommon SHARED ${jsonrpc_source_common} ${jsonrpc_header} ${jsonrpc_helper_source_common})
    target_link_libraries(unioncode-jsonrpccommon ${JSONCPP_LIBRARY})
    set_target_properties(unioncode-jsonrpccommon PROPERTIES OUTPUT_NAME unioncode-jsonrpccpp-common)
endif ()

# setup static common library
if (BUILD_STATIC_LIBS OR MSVC)
    add_library(common STATIC ${jsonrpc_source_common} ${jsonrpc_header} ${jsonrpc_helper_source_common})
    target_link_libraries(common jsoncpp_lib_static)
    set_target_properties(common PROPERTIES OUTPUT_NAME jsonrpccpp-common)

    if (NOT BUILD_SHARED_LIBS)
        add_library(unioncode-jsonrpccommon ALIAS common)
    endif ()
endif ()

# setup shared client library
if (BUILD_SHARED_LIBS)
    add_library(unioncode-jsonrpcclient SHARED ${jsonrpc_source_client} ${jsonrpc_header} ${jsonrpc_header_client} ${client_connector_source})
    add_dependencies(unioncode-jsonrpcclient unioncode-jsonrpccommon)
    target_link_libraries(unioncode-jsonrpcclient unioncode-jsonrpccommon ${client_connector_libs})
    set_target_properties(unioncode-jsonrpcclient PROPERTIES OUTPUT_NAME unioncode-jsonrpccpp-client)
endif ()

# setup static client library
if (BUILD_STATIC_LIBS OR MSVC)
    add_library(client STATIC ${jsonrpc_source_client} ${jsonrpc_header} ${jsonrpc_header_client} ${client_connector_source})
    target_link_libraries(client common ${client_connector_libs})
    set_target_properties(client PROPERTIES OUTPUT_NAME jsonrpccpp-client)

    if (NOT BUILD_SHARED_LIBS)
        add_library(unioncode-jsonrpcclient ALIAS client)
    endif ()
endif ()

# setup shared server library
if (BUILD_SHARED_LIBS)
    add_library(unioncode-jsonrpcserver SHARED ${jsonrpc_source_server} ${jsonrpc_header} ${jsonrpc_header_server} ${server_connector_source})
    add_dependencies(unioncode-jsonrpcserver unioncode-jsonrpccommon)
    target_link_libraries(unioncode-jsonrpcserver unioncode-jsonrpccommon ${server_connector_libs})
    set_target_properties(unioncode-jsonrpcserver PROPERTIES OUTPUT_NAME unioncode-jsonrpccpp-server)
endif ()

# setup static server library
if (BUILD_STATIC_LIBS OR MSVC)
    add_library(server STATIC ${jsonrpc_source_server} ${jsonrpc_header} ${jsonrpc_header_server} ${server_connector_source})
    target_link_libraries(server common ${server_connector_libs})
    set_target_properties(server PROPERTIES OUTPUT_NAME jsonrpccpp-server)

    if (NOT BUILD_SHARED_LIBS)
        add_library(jsonrpcserver ALIAS server)
    endif ()
endif ()

set(ALL_LIBS)

if (BUILD_SHARED_LIBS OR NOT BUILD_STATIC_LIBS)
    list(APPEND ALL_LIBS unioncode-jsonrpccommon unioncode-jsonrpcclient unioncode-jsonrpcserver)
endif ()

if (BUILD_STATIC_LIBS OR MSVC)

=== 3rdparty/unioncode-qscintilla214/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(unioncode-qscintilla)
set(CMAKE_CXX_STANDARD 17)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
find_package(Qt${QT_VERSION_MAJOR} COMPONENTS
    Widgets
    PrintSupport
    REQUIRED)
find_package(Dtk${DTK_VERSION_MAJOR} COMPONENTS Widget REQUIRED)

file(GLOB_RECURSE SRCS CONFIGURE_DEPENDS
    "${CMAKE_CURRENT_SOURCE_DIR}/src/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/Qsci/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/src/Qsci/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/scintilla/*/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/scintilla/*/*.cpp"
)

add_definitions(-DSCINTILLA_QT -DSCI_LEXER -DINCLUDE_DEPRECATED_FEATURES)

add_library(${PROJECT_NAME} ${SRCS})

target_include_directories(${PROJECT_NAME}
    PRIVATE
        ${DtkWidget_INCLUDE_DIRS}
        ${CMAKE_CURRENT_SOURCE_DIR}/scintilla/include
        ${CMAKE_CURRENT_SOURCE_DIR}/scintilla/src
        ${CMAKE_CURRENT_SOURCE_DIR}/scintilla/lexlib
        ${CMAKE_CURRENT_SOURCE_DIR}/src
        ${CMAKE_CURRENT_SOURCE_DIR}/src/Qsci
)

target_link_libraries(
    ${PROJECT_NAME}
    Qt${QT_VERSION_MAJOR}::Widgets
    Qt${QT_VERSION_MAJOR}::PrintSupport
    ${DtkWidget_LIBRARIES}
)

install(TARGETS ${PROJECT_NAME} ARCHIVE DESTINATION ${LIBRARY_INSTALL_PREFIX})

=== 3rdparty/unioncode-qtermwidget-0.14.1/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0 FATAL_ERROR)
# CMP0000: Call the cmake_minimum_required() command at the beginning of the top-level
# CMakeLists.txt file even before calling the project() command.
# The cmake_minimum_required(VERSION) command implicitly invokes the cmake_policy(VERSION)
# command to specify that the current project code is written for the given range of CMake
# versions.
project(qtermwidget)

#include(GNUInstallDirs)
include(GenerateExportHeader)
#include(CMakePackageConfigHelpers)
include(CheckFunctionExists)
#include(CheckIncludeFile)

option(UPDATE_TRANSLATIONS "Update source translation translations/*.ts files" OFF)
option(BUILD_EXAMPLE "Build example application. Default OFF." OFF)
option(QTERMWIDGET_USE_UTEMPTER "Uses the libutempter library. Mainly for FreeBSD" OFF)
option(QTERMWIDGET_BUILD_PYTHON_BINDING "Build python binding" OFF)
option(USE_UTF8PROC "Use libutf8proc for better Unicode support. Default OFF" OFF)

#set(QTERMWIDGET_VERSION "${QTERMWIDGET_VERSION_MAJOR}.${QTERMWIDGET_VERSION_MINOR}.${QTERMWIDGET_VERSION_PATCH}")

# additional cmake files
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/cmake")
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Minimum Versions
set(QT_MINIMUM_VERSION "5.7.1")
set(LXQTBT_MINIMUM_VERSION "0.6.0")

#find_package(Qt5Widgets "${QT_MINIMUM_VERSION}" REQUIRED)
#find_package(Qt5LinguistTools "${QT_MINIMUM_VERSION}" REQUIRED)
find_package(Qt${QT_VERSION_MAJOR}Widgets REQUIRED)
find_package(Qt${QT_VERSION_MAJOR}LinguistTools REQUIRED)
if (${QT_VERSION_MAJOR} MATCHES 6)
    find_package(Qt6Core5Compat REQUIRED)
endif()
find_package(lxqt-build-tools ${LXQTBT_MINIMUM_VERSION} REQUIRED)

if(USE_UTF8PROC)
    find_package(Utf8Proc REQUIRED)
endif()

include(LXQtPreventInSourceBuilds)
include(LXQtTranslateTs)
include(LXQtCompilerSettings NO_POLICY_SCOPE)
#include(LXQtCreatePkgConfigFile)

set(QTERMWIDGET_LIBRARY_NAME unioncode-qtermwidget)

# main library
set(SRCS
    lib/BlockArray.cpp
    lib/ColorScheme.cpp
    lib/Emulation.cpp
    lib/Filter.cpp
    lib/History.cpp
    lib/HistorySearch.cpp
    lib/KeyboardTranslator.cpp
    lib/konsole_wcwidth.cpp
    lib/kprocess.cpp
    lib/kpty.cpp
    lib/kptydevice.cpp
    lib/kptyprocess.cpp
    lib/Pty.cpp
    lib/qtermwidget.cpp
    lib/Screen.cpp
    lib/ScreenWindow.cpp
    lib/SearchBar.cpp
    lib/Session.cpp
    lib/ShellCommand.cpp
    lib/TerminalCharacterDecoder.cpp
    lib/TerminalDisplay.cpp
    lib/tools.cpp
    lib/Vt102Emulation.cpp
)

# Only the Headers that need to be moc'd go here
set(HDRS
    lib/Emulation.h
    lib/Filter.h
    lib/HistorySearch.h
    lib/kprocess.h
    lib/kptydevice.h
    lib/kptyprocess.h
    lib/Pty.h
    lib/qtermwidget.h
    lib/ScreenWindow.h
    lib/SearchBar.h
    lib/Session.h
    lib/TerminalDisplay.h
    lib/Vt102Emulation.h
)

set(UI
    lib/SearchBar.ui
)

# for distribution
set(HDRS_DISTRIB
    lib/qtermwidget.h
    lib/Emulation.h
    lib/Filter.h
)

# dirs
set(KB_LAYOUT_DIR "${SOURCES_INSTALL_RPEFIX}/${QTERMWIDGET_LIBRARY_NAME}/kb-layouts")
message(STATUS "Keyboard layouts will be installed in: ${KB_LAYOUT_DIR}")

set(COLORSCHEMES_DIR "${SOURCES_INSTALL_RPEFIX}/${QTERMWIDGET_LIBRARY_NAME}/color-schemes")
message(STATUS "Color schemes will be installed in: ${COLORSCHEMES_DIR}" )

set(TRANSLATIONS_DIR "${SOURCES_INSTALL_RPEFIX}/${QTERMWIDGET_LIBRARY_NAME}/translations")
message(STATUS "Translations will be installed in: ${TRANSLATIONS_DIR}")

CHECK_FUNCTION_EXISTS(updwtmpx HAVE_UPDWTMPX)

if (${QT_VERSION_MAJOR} MATCHES 6)
    qt6_wrap_cpp(MOCS ${HDRS})
    qt6_wrap_ui(UI_SRCS ${UI})
else()
    qt5_wrap_cpp(MOCS ${HDRS})
    qt5_wrap_ui(UI_SRCS ${UI})
endif()

set(PKG_CONFIG_REQ "Qt${QT_VERSION_MAJOR}Widgets")

lxqt_translate_ts(QTERMWIDGET_QM
    TRANSLATION_DIR "lib/translations"
    UPDATE_TRANSLATIONS
        ${UPDATE_TRANSLATIONS}
    SOURCES
        ${SRCS} ${HDRS} ${UI}
    INSTALL_DIR
        ${TRANSLATIONS_DIR}
    COMPONENT
        Runtime
)

add_library(${QTERMWIDGET_LIBRARY_NAME} SHARED ${SRCS} ${MOCS} ${UI_SRCS} ${QTERMWIDGET_QM})
target_link_libraries(${QTERMWIDGET_LIBRARY_NAME} Qt${QT_VERSION_MAJOR}::Widgets)
if (${QT_VERSION_MAJOR} MATCHES 6)
    target_link_libraries(${QTERMWIDGET_LIBRARY_NAME} Qt6::Core5Compat)
endif()

if(APPLE)
    target_compile_definitions(${QTERMWIDGET_LIBRARY_NAME}
        PRIVATE
            "HAVE_UTMPX"
            "UTMPX_COMPAT"
    )
endif()

if(HAVE_UPDWTMPX)
    target_compile_definitions(${QTERMWIDGET_LIBRARY_NAME}
        PRIVATE
            "HAVE_UPDWTMPX"
    )
endif()

if (QTERMWIDGET_USE_UTEMPTER)
    CHECK_INCLUDE_FILE(utempter.h HAVE_UTEMPTER)
    if (HAVE_UTEMPTER)
        target_compile_definitions(${QTERMWIDGET_LIBRARY_NAME} PRIVATE
                "HAVE_UTEMPTER"
        )
        target_link_libraries(${QTERMWIDGET_LIBRARY_NAME} ulog)
    endif()
endif()

if (UTF8PROC_FOUND)
    target_compile_definitions(${QTERMWIDGET_LIBRARY_NAME}
        PRIVATE
            "HAVE_UTF8PROC"
    )
    target_include_directories(${QTERMWIDGET_LIBRARY_NAME}
        INTERFACE
            ${UTF8PROC_INCLUDE_DIRS}
    )
    target_link_libraries(${QTERMWIDGET_LIBRARY_NAME}
        ${UTF8PROC_LIBRARIES}
    )
    string(APPEND PKG_CONFIG_REQ ", libutf8proc")
endif()

if(APPLE)
    set (CMAKE_SKIP_RPATH 1)
    # this is a must to load the lib correctly
    set_target_properties(${QTERMWIDGET_LIBRARY_NAME} PROPERTIES INSTALL_NAME_DIR ${CMAKE_INSTALL_FULL_LIBDIR})
endif()

target_compile_definitions(${QTERMWIDGET_LIBRARY_NAME}
    PRIVATE
        "KB_LAYOUT_DIR=\"${KB_LAYOUT_DIR}\""
        "COLORSCHEMES_DIR=\"${COLORSCHEMES_DIR}\""
        "TRANSLATIONS_DIR=\"${TRANSLATIONS_DIR}\""
        "HAVE_POSIX_OPENPT"
        "HAVE_SYS_TIME_H"
        "QT_USE_QSTRINGBUILDER"
        "QT_NO_CAST_FROM_ASCII"
        "QT_NO_CAST_TO_ASCII"
        "QT_NO_URL_CAST_FROM_STRING"
        "QT_NO_CAST_FROM_BYTEARRAY"
)


generate_export_header(${QTERMWIDGET_LIBRARY_NAME}
    EXPORT_FILE_NAME "${CMAKE_CURRENT_BINARY_DIR}/lib/qtermwidget_export.h"
    EXPORT_MACRO_NAME QTERMWIDGET_EXPORT
)

target_include_directories(${QTERMWIDGET_LIBRARY_NAME}
    PUBLIC
        "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/lib>"
        "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/lib>"
    INTERFACE
        "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
        "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/${QTERMWIDGET_LIBRARY_NAME}>"
)

# keyboard layouts
install(DIRECTORY
    lib/kb-layouts/
    DESTINATION "${KB_LAYOUT_DIR}"
    COMPONENT Runtime
    FILES_MATCHING PATTERN "*.keytab"
)
# color schemes
install(DIRECTORY
    lib/color-schemes/
    DESTINATION "${COLORSCHEMES_DIR}"
    COMPONENT Runtime
    FILES_MATCHING PATTERN "*.*schem*"
)

install(TARGETS ${QTERMWIDGET_LIBRARY_NAME} LIBRARY DESTINATION ${LIBRARY_INSTALL_PREFIX})

=== assets/configures/CMakeLists.txt ===
file(GLOB SUPPORTFILES "${CMAKE_CURRENT_SOURCE_DIR}/*.support")
file(GLOB DESKTOPFILES "${CMAKE_CURRENT_SOURCE_DIR}/*.desktop")
file(GLOB ICON "${CMAKE_CURRENT_SOURCE_DIR}/*.svg")

install(FILES ${SUPPORTFILES} DESTINATION "${SOURCES_INSTALL_RPEFIX}/configures")
install(FILES ${DESKTOPFILES} DESTINATION "/usr/share/applications")
install(FILES ${ICON} DESTINATION "${SOURCES_INSTALL_RPEFIX}/configures/icons")

=== src/app/CMakeLists.txt ===
project(deepin-unioncode)

add_executable(${PROJECT_NAME} main.cpp)

add_definitions(
    -DEXTEND_BACKTRACE
    )

target_link_libraries(
    ${PROJECT_NAME}
    duc-framework
    duc-common
    ${QtUseModules}
    ${PkgUseModule}
    ${DtkWidget_LIBRARIES}
    )

install(TARGETS ${PROJECT_NAME} DESTINATION ${RUNTIME_INSTALL_RPEFIX})

=== src/base/CMakeLists.txt ===
project(duc-base)

FILE(GLOB_RECURSE PROJECT_SOURCES
    "${CMAKE_CURRENT_SOURCE_DIR}/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/*/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*/*.cpp"
)

add_library(
    ${PROJECT_NAME}
    STATIC
    ${PROJECT_SOURCES}
)

# let code be position independent
set_property(TARGET ${PROJECT_NAME} PROPERTY POSITION_INDEPENDENT_CODE ON)

find_package(Dtk${DTK_VERSION_MAJOR} COMPONENTS Widget Core Gui REQUIRED)

target_link_libraries(
    ${PROJECT_NAME}
    ${DtkWidget_LIBRARIES}
    ${DtkCore_LIBRARIES}
)

install(TARGETS ${PROJECT_NAME} DESTINATION ${LIBRARY_INSTALL_PREFIX})
#recursion install head file
install(DIRECTORY
    ${CMAKE_CURRENT_SOURCE_DIR}
    DESTINATION
    ${INCLUDE_INSTALL_RPEFIX}
    FILES_MATCHING PATTERN "*.h"
    )

# config pkgconfig file
configure_file(${CMAKE_SOURCE_DIR}/assets/dev/${PROJECT_NAME}/${PROJECT_NAME}.pc.in ${PROJECT_NAME}.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

# config cmake file
configure_file(${CMAKE_SOURCE_DIR}/assets/dev/${PROJECT_NAME}/${PROJECT_NAME}Config.cmake.in ${PROJECT_NAME}Config.cmake @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})

=== src/common/CMakeLists.txt ===
project(duc-common)

include(${CMAKE_SOURCE_DIR}/3rdparty/unioncode-jsonrpccpp.cmake)

install(FILES ${CMAKE_SOURCE_DIR}/src/common/resource/icons/ide.svg DESTINATION ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/scalable/apps/)

configure_file(util/config.h.in config.h)

set(CMAKE_CXX_STANDARD 17)

add_definitions(
    -DCOMMON_LIBRARY
    )

FILE(GLOB COMMON_FILES
    "${CMAKE_CURRENT_SOURCE_DIR}/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/*/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/*/*/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*/*/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/*/*/*/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*/*/*/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.json"
    )

add_library(
    ${PROJECT_NAME}
    SHARED
    ${COMMON_FILES}
    resource/common.qrc
)

target_include_directories(${PROJECT_NAME}
    PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}
)

find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Concurrent REQUIRED)

target_link_libraries(
    ${PROJECT_NAME}
    unioncode-jsonrpcclient
    Qt${QT_VERSION_MAJOR}::Network
    Qt${QT_VERSION_MAJOR}::Concurrent
    ${DtkWidget_LIBRARIES}
    )

install(TARGETS ${PROJECT_NAME} DESTINATION ${LIBRARY_INSTALL_PREFIX})
#recursion install head file
install(DIRECTORY
    ${CMAKE_CURRENT_SOURCE_DIR}
    DESTINATION
    ${INCLUDE_INSTALL_RPEFIX}
    FILES_MATCHING PATTERN "*.h"
    )

# config pkgconfig file
configure_file(${CMAKE_SOURCE_DIR}/assets/dev/${PROJECT_NAME}/${PROJECT_NAME}.pc.in ${PROJECT_NAME}.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

# config cmake file
configure_file(${CMAKE_SOURCE_DIR}/assets/dev/${PROJECT_NAME}/${PROJECT_NAME}Config.cmake.in ${PROJECT_NAME}Config.cmake @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})

=== debian/changelog ===
deepin-unioncode (1.4.13-1) unstable; urgency=medium

  [ luzhen ]
  * Bug fix

  [ Deepin Packages Builder ]
  * update

 -- Deepin Packages Builder <packages@linuxdeepin.com>  Wed, 14 May 2025 13:16:16 +0800

deepin-unioncode (1.4.10) UNRELEASED; urgency=medium

  * Adapt qt6.8

 -- luzhen <luzhen@uniontech.com>  Wed, 23 Apr 2025 09:31:26 +0800

deepin-unioncode (1.4.9) UNRELEASED; urgency=medium

  * Bug fix

 -- luzhen <luzhen@uniontech.com>  Mon, 21 Apr 2025 14:06:39 +0800

deepin-unioncode (1.4.8) stable; urgency=medium

  * bug fix

 -- luzhen <luzhen@uniontech.com>  Fri, 14 Mar 2025 09:49:16 +0800

deepin-unioncode (1.4.7) unstable; urgency=medium

  * Bug fix

 -- luzhen <luzhen@uniontech.com>  Thu, 13 Mar 2025 17:10:00 +0800

deepin-unioncode (1.4.6) stable; urgency=medium

  * Bug fix

 -- luzhen <luzhen@uniontech.com>  Mon, 10 Mar 2025 17:01:50 +0800

deepin-unioncode (1.4.5) unstable; urgency=medium

  * Disable smartut
  * Add model change feature
  * Bug fix

 -- luzhen <luzhen@uniontech.com>  Thu, 27 Feb 2025 15:30:36 +0800

deepin-unioncode (1.4.4) UNRELEASED; urgency=medium

  * Adapt to qt6.8

 -- luzhen <luzhen@uniontech.com>  Fri, 21 Feb 2025 14:39:48 +0800

deepin-unioncode (1.4.1) stable; urgency=medium

  * Bug fix

 -- luzhen <luzhen@uniontech.com>  Tue, 14 Jan 2025 10:26:36 +0800

deepin-unioncode (1.4.0) unstable; urgency=medium

  * Add session manager
  * Optimize toolchain search
  * Add smart terminal

 -- luzhen <luzhen@uniontech.com>  Tue, 24 Dec 2024 10:08:37 +0800

deepin-unioncode (1.3.17) stable; urgency=medium

  * bugfix

 -- luzhen <luzhen@uniontech.com>  Thu, 14 Nov 2024 21:08:04 +0800

=== debian/control ===
Source: deepin-unioncode
Section: libdevel
Priority: optional
Maintainer: Deepin Packages Builder <packages@linuxdeepin.com>
Build-Depends:
 debhelper (>=9),
 cmake,
 qt6-base-dev,
 qt6-tools-dev-tools,
 qt6-tools-dev,
 qt6-webengine-dev,
 qt6-multimedia-dev,
 libdtk6widget-dev,
 libdtk6gui-dev,
 libdtk6core-dev,
 libkf6syntaxhighlighting-dev,
 qt6-5compat-dev,
 libqt5scripttools5 | hello,
 lxqt-build-tools (>= 0.6.0~),
 libssl-dev,
 llvm (>=1:7~),
 llvm-dev (>=1:7~),
 libclang-dev (>=1:7~),
 libutf8proc-dev,
 libmicrohttpd-dev,
 libjsoncpp-dev,
 libargtable2-dev,
 libhiredis-dev,
 catch,
 libzstd-dev,
 libjson-c-dev,
 libelf-dev,
 libcapstone-dev,
 libunwind-dev, 
 libelfin-dev,
 libdbus-1-dev,
 libxi-dev,
 clang[!mips64],
 doxygen,
 libyaml-cpp-dev,
 libcmark-dev,
 libchardet-dev,
 libuchardet-dev (>= 0.0.6),
 libicu-dev
Standards-version: 3.9.8
Homepage: http://www.deepin.org

Package: deepin-unioncode
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Recommends: cmake,
            make,
            gdb,
            g++,
            gcc,
            git,
            clangd-13|clangd,
            python3-pip
Description: IDE 'Deepin Union Code'
 Lightweight cross-platform integrated development environment

Package: libdeepin-unioncode-dev
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},deepin-unioncode
Description: IDE 'Union Code' devel library
 IDE 'Union Code' development can be carried out through this library

## deepin-unioncode 1.4.16

=== debian/changelog ===
deepin-unioncode (1.4.16-1) unstable; urgency=medium

  [ luzhen ]
  * Bug fix

  [ Deepin Packages Builder ]
  * update

 -- Deepin Packages Builder <packages@linuxdeepin.com>  Thu, 17 Jul 2025 16:30:09 +0800

=== debian/control ===
--- 
+++ 
@@ -5,16 +5,19 @@
 Build-Depends:
  debhelper (>=9),
  cmake,
- qt6-base-dev,
- qt6-tools-dev-tools,
- qt6-tools-dev,
- qt6-webengine-dev,
+ qt6-qmake | qt5-qmake,
+ qt6-base-dev | qtbase5-dev,
+ qt6-tools-dev-tools | qttools5-dev-tools,
+ qt6-tools-dev | qttools5-dev,
+ qt6-webengine-dev | qtwebengine5-dev,
  qt6-multimedia-dev,
- libdtk6widget-dev,
- libdtk6gui-dev,
- libdtk6core-dev,
- libkf6syntaxhighlighting-dev,
- qt6-5compat-dev,
+ libdtk6widget-dev | libdtkwidget-dev,
+ libdtk6gui-dev | libdtkgui-dev,
+ libdtk6core-dev | libdtkcore-dev,
+ libdtk6core5-bin |libdtkcore5-bin,
+ libkf6syntaxhighlighting-dev | libkf5syntaxhighlighting-dev,
+ qt6-script-dev | qtscript5-dev,
+ qt6-5compat-dev | hello,
  libqt5scripttools5 | hello,
  lxqt-build-tools (>= 0.6.0~),
  libssl-dev,

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/default.mk
export QT_SELECT=5
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

define detect_qt_version
ifneq (,$(shell which qmake6 2>/dev/null))
    QT_DIR="/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/Qt6"
else
    QT_DIR="/usr/lib/$(DEB_HOST_MULTIARCH)/cmake/Qt5"
endif
endef

$(eval $(call detect_qt_version))

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
	  -DCMAKE_BUILD_TYPE=Release \
	  -DCMAKE_INSTALL_PREFIX=/usr \
      -DVERSION=$(PACK_VER) \
	  -DQT_DIR=$(QT_DIR) \
      -DAPP_VERSION=$(DEB_VERSION_UPSTREAM) -DVERSION=$(DEB_VERSION_UPSTREAM) LIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)
